abstract sig FSObject {
  parent: lone Dir
}

sig File extends FSObject {}

sig Dir extends FSObject {
  contents: set FSObject
}

one sig Root extends Dir {}

// Root is the root
fact { no Root.parent }

// A directory is the parent of its contents
fact { all d: Dir, o: d.contents | o.parent = d }

// The contents path is acyclic
fact { no d: Dir | d in d.^contents }

fact { all o: FSObject | some o.parent => o in o.parent.contents }

fact { all o: FSObject | o in Root.*contents }

pred show {}
run show for 5 


